<script lang="ts">
import Vue from 'vue';
import { kebabCase } from 'lodash';

export default Vue.extend({
  name: 'MicrositeCardBlock',
  props: {
    data: {
      type: Object,
      required: true,
    },
    partner: {
      type: Object,
      required: false,
      default: null,
    },
  },
  computed: {
    calculateCols() {
      return (card, index) => {
        if (!card.description) {
          if (this.data.cards.length % 2 === 0) {
            return 6;
          } else if (this.data.cards.length % 3 === 0) {
            return 4;
          } else {
            return index === 0 ? 6 : 4;
          }
        } else {
          return this.data.cards.length % 2 !== 0 && index === 0 ? 12 : 6;
        }
      };
    },
  },
  methods: {
    kebabCase,
  },
});
</script>

<template>
  <section class="card-block light-background">
    <SlpRow class="block-container">
      <SlpColumn :cols="12" class="block__header">
        <SlpTypography
          v-if="data.header"
          tag="h2"
          variant="heading3"
          class="title"
          >{{ data.header }}
        </SlpTypography>
      </SlpColumn>
    </SlpRow>
    <SlpRow
      :style="{
        justifyContent: 'flex-start',
      }"
    >
      <SlpColumn
        v-for="(card, index) in data.cards"
        :key="index"
        :cols="calculateCols(card, index)"
        size="md"
        class="block__col"
      >
        <div class="block">
          <div class="block__wrapper light-background">
            <div class="block__content-top">
              <div v-if="card.icon" class="block__category slp-flex slp-mb-24">
                <SlpIcon :name="card.icon" variant="marketing" size="md" />
              </div>
              <SlpTypography
                v-if="card.header"
                tag="h3"
                :variant="card.description ? 'heading5-bold' : 'heading4-bold'"
                class="block__title"
                >{{ card.header }}
              </SlpTypography>
              <SlpTypography
                v-if="card.description"
                tag="div"
                variant="body2"
                class="block__description"
                ><span v-html="$md.render(card.description)"></span>
              </SlpTypography>
              <SlpButton
                v-if="card.link"
                variant="tertiary"
                class="learn-more"
                :href="card.link"
                :data-ga-name="`${card.header} learn more CTA`"
                data-ga-location="body"
                >Learn More
                <SlpIcon name="chevron-lg-right" variant="product" />
              </SlpButton>
            </div>
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style scoped lang="scss">
.card-block {
  background-color: $color-surface-800;
  margin-bottom: 16px;
  position: relative;
  overflow-x: hidden;
  &.light-background {
    background: $color-primary-300;
    &:after {
      background: $color-primary-300;
    }
  }
  &:after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-800;
  }
  .learn-more {
    padding-left: 0;
    margin-top: auto;
  }
  @media (max-width: $breakpoint-md) {
    padding: $spacing-24 0;
  }

  h2 {
    font-size: $text-heading-2;
    line-height: $line-height-heading-2;
    font-weight: $font-weight-bold;
  }

  .block {
    display: flex;
    position: relative;
    height: 100%;

    &__wrapper {
      display: flex;
      flex-direction: column;
      transition: all 0.3s ease-in-out;
      justify-content: space-between;
      padding: $spacing-32;
      background: $color-primary-300;
      &.light-background {
        background: $color-surface-800;
      }
      flex: 1;
      border-radius: $spacing-4;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-8 $spacing-16 $spacing-8 0;
      }
      @media (max-width: $breakpoint-md) {
        margin: $spacing-8 0;
      }
    }

    &__header {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    &__image {
      max-width: 100%;
    }

    &__link {
      color: $color-text-300;
      padding-left: 0;
    }

    &__title {
      margin-bottom: $spacing-16;
    }

    &__description {
      margin-bottom: $spacing-16;
      &:deep(a:hover) {
        text-decoration: underline;
      }

      &:deep(p:not(:last-of-type)) {
        margin-bottom: 16px;
      }
    }

    &__list {
      margin-bottom: $spacing-16;

      .item {
        margin-bottom: $spacing-16;
        display: flex;
      }

      .bullet {
        margin-right: $spacing-8;
      }
    }

    &__content-top {
      display: flex;
      flex-basis: 100%;
      flex-direction: column;
      p,
      h3,
      li {
        color: $color-text-300;
      }

      :last-child {
        margin-bottom: 0;
      }
    }
    &__col {
      width: 100%;
    }
  }
}
.title {
  margin-top: 32px;
  margin-bottom: 64px;
  &.small-margin {
    margin-bottom: 24px;
  }
}
</style>
